<?php
/**
 * Action Plugin DokuTwitter
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Michael Klier chi@chimeric.de
 */
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_INC.'inc/plugin.php');

/**
 * All DokuWiki plugins to interfere with the event system
 * need to inherit from this class
 */
class action_plugin_dokutwitter extends DokuWiki_Action_Plugin {

    /**
     * return some info
     */
    function getInfo() {
        return array(
                'author' => 'Michael Klier',
                'email'  => 'chi@chimeric.de',
                'date'   => '2007-09-11',
                'name'   => 'DokuTwitter',
                'desc'   => 'Sends changes notifications of your wiki to your twitter account.',
                'url'    => 'http://www.chimeric.de/projects/dokuwiki/plugin/dokutwitter'
            );
    }

     /**
      * Registers a callback function for a given event
      */
    function register(&$controller) {
        $controller->register_hook('IO_WIKIPAGE_WRITE', 'AFTER', $this, 'twitterUpdateStatus');
    }

    /**
     * updates the twitter account
     *
     * @author Michael Klier <chi@chimeric.de>
     */
    function twitterUpdateStatus(&$event, $param) {
        global $conf;
        global $lang;
        global $ID;
        global $SUM;
        global $INFO;

        // do nothing on revision saving or minor changes
        if($event->data[3]) return;
        if($_REQUEST['minor']) return;

        // dont update status if not in group dokutwitter
        if($this->getConf('restrict2group') && !in_array('dokutwitter',$INFO['userinfo']['grps'])) return;

        // build tweet
        $tweet = '';
        $tweet = $conf['title'] . ': ';

        if(!$INFO['exists']) {
            $tweet .= str_replace(':','',$lang['mail_newpage']) . ' ';
        } else {
            $tweet .= str_replace(':','',$lang['mail_changed']) . ' ';
        }

        $tweet .= $lang['by'] . ' ' . $INFO['client'] . '.' . "\n";
        if($SUM) $tweet .= $lang['summary'] . ': '. $SUM . '.' .  "\n";

        $tweet .= 'URL: ';

        if(!$INFO['exists']) {
            $tweet .= wl($ID,'',true);
        } else {
            $tweet .= wl($ID,'do=diff',true);
        }

        $user = $this->getConf('user');
        $pass = $this->getConf('pass');

        $url = 'http://twitter.com/statuses/update.xml';

        require_once(DOKU_INC.'inc/HTTPClient.php');
        $http = new DokuHTTPClient();

        // uncomment for debugging
        //$http->debug = true;

        // set twitt twitter related  headers
        $http->headers['X-Twitter-Client']         = 'DokuTwitter';
        $http->headers['X-Twitter-Client-Version'] = '1.0';
        $http->headers['X-Twitter-Client-URL']     = 'http://chimeric.de/DokuTwitter.xml';

        $http->user = $user;
        $http->pass = $pass;
        $http->referer = ''; // unset referer just in case

        $http->post($url, array('status'=>utf8_encode($tweet)));
    }
}

// setup: vim:ts=4:sw=4:enc=utf8
